<?php
  // If not called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

function ManageNoPaste(){
  global $context, $scripturl, $txt;

  isAllowedTo('admin_forum');
  
  if (allowedTo('admin_forum')){
     
    InitNoPaste();
    loadLanguage('NoPaste');
    loadTemplate('NoPaste');

    $subActions = array(
      'settings' => 'NoPasteAdminSettings',
      'browse' => 'NoPasteAdminShowSnippets',
      'delete' => 'NoPasteAdminDeleteSnippets',
      'save' => 'NoPasteAdminSettings'
	  );
    
   	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'settings';
  	$context['sub_action'] = $_REQUEST['sa'];
        
   	adminIndex('manage_nopaste');
    
  	// Setup the admin tabs.
  	$context['admin_tabs'] = array(
  		'title' => $txt['lbl_TitleSettings'],
  		'help' => 'nopaste_settings',
  		'description' => $txt['txt_adminDescription'],
  		'tabs' => array(
      		'npsettings' => array(
  				'title' => $txt['lbl_Settings'],
  				'description' => $txt['txt_adminDescription2'],
  				'href' => $scripturl . '?action=managenopaste',
				  'is_selected' => false,
		  		'is_last' => false
          ),
          'npbrowse' => array(
  				'title' => $txt['lbl_Browse'],
  				'description' => $txt['txt_adminDescription'],
  				'href' => $scripturl . '?action=managenopaste;sa=browse',
				  'is_selected' => false,
		  		'is_last' => true
          )          
      )
  	);
    
    $context['page_title'] = $txt['lbl_TitleSettings'];
  
  // Hide bars if TinyPortal is installed
  if (function_exists("tp_hidebars"))
    tp_hidebars();
  
	// Call the right function.
	$subActions[$_REQUEST['sa']]();
  }
}
function NoPasteAdminSettings(){
  global $context, $sourcedir;

  $context['sub_template'] = 'showsettings';
  $context['admin_area']= 'manage_nopaste';
  $context['admin_tabs']['tabs']['npsettings']['is_selected'] = true;

  if (isset($_REQUEST['api']) && isset($_REQUEST['api2'])){
    $api = $_REQUEST['api'];
    $api2 = $_REQUEST['api2'];
    $theme = isset($_REQUEST['theme']) ? $_REQUEST['theme'] : '';
    
    // We'll need the utility functions from here.
    require_once($sourcedir . '/Subs.php');
    
    updateSettings(
      array('nopaste_public_key' => !empty($api) ? $api : '',
            'nopaste_private_key' => !empty($api2) ? $api2 : '',
            'nopaste_captcha_theme' => !empty($theme) ? $theme : 'clean'
    ));
   	redirectexit('action=managenopaste');
  }
}
function NoPasteAdminShowSnippets(){
  global $scripturl, $context, $db_prefix, $txt, $modSettings;

  $context['sub_template'] = 'showsnippets';
  $context['admin_area']= 'manage_nopaste';
  $context['admin_tabs']['tabs']['npbrowse']['is_selected'] = true;
  	
	$request = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}pastes", __FILE__, __LINE__);
	list ($num_snippets) = mysql_fetch_row($request);
	mysql_free_result($request);

	$context['page_index'] = constructPageIndex($scripturl . '?action=managenopaste',$_REQUEST['start'], $num_snippets, 10);
	$context['start'] = (int) $_REQUEST['start'];

  $query = db_query("
    SELECT cryptid, name, uid, description, code, tab_length, code_lang, time, ip
    FROM ({$db_prefix}pastes)
    LIMIT $context[start], 10",__FILE__,__LINE__);

		while ($row = mysql_fetch_assoc($query))
		{
			$uid = $row['uid'];

      $name = (stripslashes($row['name']) == '0') ? ($txt['lbl_Guest']) : (stripslashes($row['name']));
      $name = ($uid == 0) ? $name : '<a href="'. $scripturl . '?action=profile;u='. $uid . '">'. $name . '</a>';
                
      $description = stripslashes($row['description']);
      $description = preg_replace("/\n/", "<br />\n", $description);
      $description = ($description == '0') ? ('('. $name . $txt['no_Description']) : $description;
      
      $codelang = $row['code_lang'];
      $pastelink = ($modSettings['queryless_urls']) ? ($scripturl . '/id,' . $row['cryptid'] . '.html') : ($scripturl . '?action=nopaste&sa=show&id=' . $row['cryptid']);
      
			$context['nopaste']['snippets'][] = array(
				'id' => $row['cryptid'],
				'name' => $name,
				'description' => $description, 
        'date' => timeformat($row['time'], true),
        'lang' => $codelang,
        'ip' => '<a href="'. $scripturl. '?action=trackip;searchip='. $row['ip']. '">'. $row['ip']. '</a>',
        'link' => $pastelink
			);
		}
    mysql_free_result($query);	  
}

function NoPasteAdminDeleteSnippets(){
  global $scripturl, $context, $db_prefix, $txt, $modSettings;

  if (isset($_REQUEST['delete_all'])){
      $condition ='<> \'\'';
  } else {
    if (isset($_REQUEST['delete'])){
       $delete = $_REQUEST['delete'];
       $condition = 'IN (\'' . implode('\', \'', $delete) . '\')'; 
       }
  } 

 	// Delete the snippets  
  if (isset($condition)){
  	db_query("
  		DELETE FROM {$db_prefix}pastes
  		WHERE cryptid $condition", __FILE__, __LINE__);
  }
  
  NoPasteAdminShowSnippets();
}

function NoPaste(){
	global $context, $scripturl;

  // If TinyPortal is installed, strip the linktree ;)
  if (function_exists("TPstrip_linktree")){
     TPstrip_linktree();
	}

  // Add NoPaste to link tree
	$context['linktree'][] = array(
  	'url' => $scripturl . '?action=nopaste',
	'name' => 'NoPaste');	
  
  $context['page_title'] = $context['forum_name'] . ' - ' . 'NoPaste';
  
  InitNoPaste();

  loadLanguage('NoPaste');
  loadTemplate('NoPaste');
	
	$subActions = array(
	 'show' => 'ShowSnippet',
	 'add' => 'AddSnippet',
	 'del' => 'DelPaste'
   );

	if (isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]))
		$subActions[$_REQUEST['sa']]();
	else
  	ShowForm();
}
function ShowSnippet(){
  global $context, $txt, $sourcedir, $db_prefix, $scripturl, $modSettings;

  isAllowedTo('view_snippets');
  allowedTo('view_snippets');
    
  // Add NoPaste to link tree
	$context['linktree'][] = array(
  	'url' => $scripturl . '?action=nopaste;id=' . ((!empty($_GET['id'])) ? $_GET['id'] : ''),
	  'name' => 'NoPaste');	
    
  loadLanguage('NoPaste');
  loadTemplate('NoPaste');
  
  InitNoPaste();
  
  require_once($sourcedir . '/NoPasteHighlight.php');
  
  $context['page_title'] = $context['forum_name'] . ' - ' . 'NoPaste';
	$context['selected'] = 'ShowPaste';
  $context['sub_template'] = 'showpaste';
  
  if(isset($_GET['id'])){
    if(preg_match('/^[a-fA-F\d]{10}$/', $_GET['id'])){
      $id = $_GET['id'];
      
      $query = db_query("
        SELECT cryptid, name, uid, description, code, tab_length, code_lang, time, ip
        FROM ({$db_prefix}pastes)
        WHERE cryptid='$id'
        LIMIT 1",__FILE__,__LINE__);

      if(mysql_num_rows($query) > 0){
          $row = mysql_fetch_assoc($query);
          $uid = $row['uid'];
          
          $name = (stripslashes($row['name']) == '0') ? ($txt['lbl_Guest']) : (stripslashes($row['name']));
          $name = ($uid == 0) ? $name : '<a href="'. $scripturl . '?action=profile;u='. $uid . '">'. $name . '</a>';
                    
          $description = stripslashes($row['description']);
          $description = preg_replace("/\n/", "<br />\n", $description);
          $description = ($description == '0') ? ('('. $name . $txt['no_Description']) : doUBBC($description, true);
          
          $codelang = $row['code_lang'];
          
          $code = htmlspecialchars($row['code']);
          $code = preg_replace("/  /", "&nbsp; ", $code);
          $code = preg_replace("/</", "&lt;", $code);
          $code = preg_replace("/>/", "&gt;", $code);
          $code = stripslashes__recursive($code);
          $code = syntax_highlight($code, $codelang);
          $code = str_replace("\t", str_repeat('&nbsp;', $row['tab_length']), $code);

          
          $explode = explode("\n", $code);
          $parsedcode = "<ol id=\"codeblock\">\n";

          for($i = 0; $i < count($explode); $i++)
          {   
              $classnumber = $i % 2;

              if(trim($explode[$i]) != '')
              {   
                  $parsedcode .= "    <li class=\"rowstyle" . $classnumber . "\">" . $explode[$i] . "</li>\n";
              }
              else
              {
                  $parsedcode .= "    <li class=\"rowstyle" . $classnumber . "\">&nbsp;</li>\n";
              }
          }
          $parsedcode .= "</ol>\n"; 
          $deletelink = ($modSettings['queryless_urls']) ? ('<a href="'. $scripturl . '/action,nopaste/sa,del/id,'.$id.'.html">'. $txt['lbl_Delete'] . '</a>') : ('<a href="'. $scripturl . '?action=nopaste;sa=del;id='.$id.'">'. $txt['lbl_Delete'] . '</a>');
          
          $context['nopaste'] = array(
            'name' => $name,
            'uid' => $row['uid'],
            'date' => timeformat($row['time'], true),
            'lang' => $codelang,
            'tabw' => $row['tab_length'],
            'ip' => $row['ip'],
            'description' => $description,
            'deletelnk' => $deletelink,
            'code' => $parsedcode
          );
      } else {
// ID NotFound!
      fatal_error($txt['err_NotFound']);
      }
        mysql_free_result($query);
    } else {
// Wrong ID-Format!
      fatal_error($txt['err_WrongFormat']);
    }
  }
}
function ShowForm(){
  global $context, $txt, $modSettings;
  
  IsAllowedTo('use_nopaste');
  allowedTo('use_nopaste');

	$context['selected'] = 'ShowForm';

  $context['nopaste']['captcha'] = allowedTo('use_captcha'); 
  $context['nopaste']['captcha_key'] = isset($modSettings['nopaste_public_key']) ? $modSettings['nopaste_public_key'] : '';
  $context['nopaste']['name'] = $context['user']['is_logged'] ? $context['user']['name'] : (isset($_COOKIE['SMF_NPName']) ? $_COOKIE['SMF_NPName'] : $txt['lbl_Guest']);
  $context['nopaste']['userid'] = $context['user']['is_logged'] ? $context['user']['id'] : '0';
}
function AddSnippet(){
  global $scripturl, $sourcedir, $context, $modSettings, $db_prefix, $txt;
  
  IsAllowedTo('add_snippets');
  allowedTo('add_snippets');
  
  require_once($sourcedir . '/QueryString.php');
  
  // Important to avoid hacking
  cleanRequest();
  
  if (allowedTo('use_captcha') && !$context['user']['is_admin'])
     validateCaptcha();
  
  $_SESSION['code_lang'] = trim($_POST['code_lang']);
  $_SESSION['tab_length'] = trim($_POST['tab_length']);
  $_SESSION['name'] = trim($_POST['name']);
  $_SESSION['description'] = $_POST['description'];
  $_SESSION['code'] = @$_POST['code'];
  $_SESSION['userid'] = @$_POST['userid'];
                                                                   
    if(trim($_SESSION['code']) == ''){
        fatal_error($txt['err_noCode']);
    } else {
      $codelang = (in_array($_SESSION['code_lang'], $context['nopaste']['code_language_array'])) ? ($_SESSION['code_lang']) : ('Plain Text');
      $tablength = (is_numeric($_SESSION['tab_length']) AND $_SESSION['tab_length'] >= 0 AND $_SESSION['tab_length'] <= 9) ? ($_SESSION['tab_length']) : (4);
      $name = ($_SESSION['name'] == '') ? (0) : (addslashes(htmlspecialchars($_SESSION['name'])));
      $description = (trim($_SESSION['description']) == '') ? (0) : (addslashes(htmlspecialchars($_SESSION['description'])));
      $code = $_SESSION['code'];
      $ip = $_SERVER['REMOTE_ADDR'];
//      $time = strftime('%Y-%m-%d', forum_time(false));
      $uid = (empty($_SESSION['userid'])) ? '0' : $_SESSION['userid'];
      
      $crypt_id = substr(md5(microtime()),0,10);

      db_query("
        INSERT INTO {$db_prefix}pastes
          (cryptid, name, uid, description, code, tab_length, code_lang, time, ip)
    		VALUES ('$crypt_id', SUBSTRING('$name', 1, 100), '$uid', SUBSTRING('$description', 1, 255), '$code', '$tablength', SUBSTRING('$codelang', 1, 20), '" . time() . "', SUBSTRING('$ip', 1, 15))", __FILE__, __LINE__);

      $cookiename = ($name == '0') ? ('') : ($name);
      setcookie('SMF_NPName', base64_encode($cookiename), time()+3600, '/', $_SERVER['SERVER_NAME'], 0);
      
      $pastelink = (!empty($modSettings['queryless_urls'])) ? ($scripturl . '/id,' . $crypt_id . '.html') : ($scripturl . '?action=nopaste;sa=show;id=' . $crypt_id);
      $deletelink = (!empty($modSettings['queryless_urls'])) ? ('<a href="'. $scripturl . '/action,nopaste/sa,del/id,'.$crypt_id.'.html">'. $txt['lbl_Delete'] . '</a>') : ('<a href="'. $scripturl . '?action=nopaste;sa=del;id='.$crypt_id.'">'. $txt['lbl_Delete'] . '</a>');
                
      $context['sub_template'] = 'showlink';
      $context['nopaste']['link'] = '<a href="'. $pastelink. '">'. $pastelink . '</a>';
      $context['nopaste']['linkid'] = $crypt_id;
      $context['nopaste']['deletelnk'] = $deletelink;
  }
}
function DelPaste(){
  global $context, $txt, $db_prefix;
  
  IsAllowedTo('delete_snippets');
  allowedTo('delete_snippets');
  
  if (!empty($_GET['id'])){
    $id = $_GET['id'];
    
    db_query("
      DELETE FROM {$db_prefix}pastes
      WHERE cryptid='$id' 
      LIMIT 1", __FILE__, __LINE__);

    if(db_affected_rows() > 0){
      $context['nopaste']['status'] = $txt['txt_Deleted'];
    } else {
      fatal_error($txt['err_NotFound']);
    }
  } else {
    fatal_error($txt['err_idMising']);
  }
  $context['sub_template'] = 'delpaste';
}

function InitNoPaste(){
  global $context, $modSettings;

  // Setup languages
	$context['nopaste']['code_language_array'] = array("Plain Text", "C89", "C", "C++", "PHP", "Perl", "Java", "VB", "C#", "Ruby", "Python", "Pascal", "mIRC", "PL/I", "SQL", "XML", "Scheme");
  sort($context['nopaste']['code_language_array']);

  $lang_option = '';
  foreach($context['nopaste']['code_language_array'] as $optlang){
        $lang_option .= '                        <option value="'.$optlang.'"';
        if($optlang == "Plain Text"){
            $lang_option .= ' selected="selected">'.$optlang.'</option>' . "\n";
        } else {
            $lang_option .= '>'.$optlang.'</option>' . "\n";
        }
  }
    
  $context['nopaste']['languages'] = $lang_option;
  
  // Setup TABs
  $tab_option = '';
  for($i = 0; $i <= 9; $i++){
      $tab_option .= '                        <option value="'.$i.'"';
      if($i == 4){
        $tab_option .= ' selected="selected">'.$i.'</option>' . "\n";
      } else {
        $tab_option .= '>'.$i.'</option>' . "\n";
      }
  }
  $context['nopaste']['tabs'] = $tab_option;
  
  //Setup captcha themes
 	$theme_array = array('red','white','blackglass','clean');
  sort($theme_array);

  $default_theme = empty($modSettings['nopaste_captcha_theme']) ? 'clean' : $modSettings['nopaste_captcha_theme']; 

  $themes = '';
  foreach($theme_array as $opt){
        $themes .= '<option value="'.$opt.'"';
        if($opt == $default_theme){
            $themes .= ' selected="selected">'.$opt.'</option>' . "\n";
        } else {
            $themes .= '>'.$opt.'</option>' . "\n";
        }
  }
  
  $context['nopaste']['themes'] = $themes;
}
function nopaste_footer(){
  global $db_prefix, $txt;
  
  $query = db_query("
    SELECT COUNT(*)
    FROM ({$db_prefix}pastes)", __FILE__, __LINE__);

  list ($count_pastes) = mysql_fetch_row($query);
  
  mysql_free_result($query);
  
  $query = db_query("
    SELECT * 
    FROM {$db_prefix}pastes
    ORDER BY id DESC 
    LIMIT 1", __FILE__, __LINE__);
  
  $row = mysql_fetch_assoc($query);
    
  (int) $count_usage = $row['id'];
  
  mysql_free_result($query);
  
  echo '<div align="center"><a class="smalltext" href="http://www.marook-online.de">' . $txt['txt_nopaste'] . $txt['nopaste_version'] . $txt['copyright'] . '</a><br />';
  echo '<span class="smalltext" />', $count_pastes . $txt['lbl_Count'], '<br />';
  echo '<span class="smalltext" />', $count_usage . $txt['lbl_Usage'], '</div>';
}
function validateCaptcha(){
  global $modSettings, $txt, $sourcedir;
  
  require_once($sourcedir . '/reCaptchaLib.php');
  
  if (!empty($modSettings['nopaste_private_key'])){
    $privatekey = $modSettings['nopaste_private_key'];
  } else {
    fatal_error($txt['err_noKey']);
  }
  
  $resp = recaptcha_check_answer ($privatekey,
                                  $_SERVER["REMOTE_ADDR"],
                                  $_POST["recaptcha_challenge_field"],
                                  $_POST["recaptcha_response_field"]);
  
  if (!$resp->is_valid) {
    fatal_error($txt['err_wrongCaptcha'] . $resp->error . ")");
    return true;
  }
  return false;
}
?>
