<?php
function template_main(){
	global $txt, $context, $scripturl, $settings, $sourcedir;

	echo '<div style="padding: 3px;">', theme_linktree(), '</div>';
  
	echo '
  <table width="100%" border="0" cellspacing="0" cellpadding="4" align="center" class="tborder">
		<tr class="catbg">
			<td>', $txt['txt_nopaste'], '</td>
		</tr>
		<tr>
			<td class="windowbg">
          <form action="', $scripturl, '?action=nopaste&amp;sa=add" method="post" accept-charset="utf-8">
          <input type="hidden" name="userid" value="', $context['nopaste']['userid'], '" />
          <fieldset>
            <legend><label>', $txt['lbl_Settings'], '</label></legend>
            <table style="width:100%; padding:0px; border-collapse:separate; border-width:0px; text-align:left;">
              <tr>
                <td style="text-align:left; padding:0px 10px 0px 0px; width:100%;">
                    <div class="usertitle">', $txt['lbl_Title'], '</div>
                    <div class="corner"><input type="text" name="name" class="gfield" value="', $context['nopaste']['name'], '" /></div>
                </td>
                <td style="text-align:left; padding:0px 10px 0px 10px; white-space:nowrap;">
                    <div class="usertitle">', $txt['lbl_Lang'], '</div>
                    <div class="corner">
                      <select name="code_lang" class="gfield gselect">
', $context['nopaste']['languages'], '                      </select>
                    </div>
                </td>
                <td style="text-align:left; padding:0px 0px 0px 10px; white-space:nowrap;">
                    <div class="usertitle">', $txt['lbl_TabWidth'], '</div>
                    <div class="corner">
                      <select name="tab_length" class="gfield gselect">
', $context['nopaste']['tabs'], '                      </select>
                    </div>
                </td>
              </tr>
            </table>
          </fieldset><p />
          <fieldset>
          <legend><label>', $txt['lbl_Description'], '</label></legend>
            <div class="fieldsetcontent"><textarea name="description" class="gfield" style="height:60px; width:98%;" rows="10" cols="50">', $txt['default_Description'], '</textarea></div>
          </fieldset><p />
          <fieldset>
            <legend><label>', $txt['lbl_Code'], '</label></legend>
            <div class="fieldsetcontent"><textarea name="code" class="gfield" style="height:300px; width:98%;" rows="10" cols="50">', $txt['default_Code'], '</textarea></div>
          </fieldset><p />
          <fieldset>              
            <legend><label>', $txt['lbl_Send'], '</label></legend>
            <table width="100%">
              <tr>
                <td width="50%" align="center">
                  <input type="submit" name="submit" value="', $txt['lbl_Submit'], '" class="gbutton" />
                </td>';
            if ($context['nopaste']['captcha'] && !$context['user']['is_admin']){
              require_once($sourcedir . '/reCaptchaLib.php');
              echo '
                <td>
                  <script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
            			var RecaptchaOptions = {
            			   theme : \'', empty($modSettings['nopaste_captcha_theme']) ? 'clean' : $modSettings['nopaste_captcha_theme'] , '\'
            			};
            // ]]></script>
                ', recaptcha_get_html($context['nopaste']['captcha_key']), '
                </td>
              </tr>
            </table>';
            } else {
              echo '
              </tr>
            </table>';
            }
            echo '
          </fieldset>
          </form>
			</td>
		</tr>
	</table>';
  nopaste_footer();
  //print_r($context['nopaste']);
}
function template_showpaste(){
	global $txt, $context;

	echo '<div style="padding: 3px;">', theme_linktree(), '</div>';

	// Wrap this in a table (for the nice-looking heading).
	echo '
		<table width="100%" border="0" cellspacing="0" cellpadding="4" align="center" class="tborder">
			<tr class="catbg">
				<td>', $txt['lbl_ShowTitle'], '</td>
			</tr>
			<tr>
				<td class="windowbg">
          <table style="width:100%; padding:0px; border-collapse:separate; border-width:0px;">
              <tr>
                  <td style="text-align:left; padding:0px 10px 0px 0px; width:100%;">
                      <div class="usertitle"><b>', $txt['lbl_Name'], '</b></div>
                      <div class="corner">', $context['nopaste']['name'], '</div>
                  </td>
                  <td style="text-align:left; padding:0px 10px 0px 10px; white-space:nowrap;">
                      <div class="usertitle">', $txt['lbl_Lang'], '</div>
                      <div class="corner">', $context['nopaste']['lang'], '</div>
                  </td>
                  <td style="text-align:left; padding:0px 10px 0px 10px; white-space:nowrap;">
                      <div class="usertitle">', $txt['lbl_TabWidth'], '</div>
                      <div class="corner">', $context['nopaste']['tabw'], '</div>
                  </td>
                  <td style="text-align:left; padding:0px 10px 0px 10px; white-space:nowrap;">
                      <div class="usertitle">', $txt['lbl_Date'], '</div>
                      <div class="corner">', $context['nopaste']['date'], '</div>
                  </td>';
                  if ($context['user']['is_admin']){
                    echo '
                  <td style="text-align:left; padding:0px 0px 0px 10px; white-space:nowrap;">
                      <div class="usertitle">', $txt['lbl_IP'], '</div>
                      <div class="corner">', $context['nopaste']['ip'], '</div>
                  </td>
             </tr>
          </table>
          <hr /><p />';
                  } else {
                    echo '
             </tr>
          </table>
          <hr /><p />';        
        }
echo '
          <fieldset>
          <legend><label>', $txt['lbl_Description2'], '</label></legend>
          <p style="text-align:left;">', $context['nopaste']['description'], '
          </fieldset><p />
          <fieldset>
          <legend><label>', $txt['lbl_Code2'];

if (($context['nopaste']['name'] == $context['user']['name']) || ($context['nopaste']['uid'] == $context['user']['id'])){
  echo '&nbsp;&nbsp;&nbsp;&nbsp;(', $context['nopaste']['deletelnk'], ')</label></legend>';
} else {
  echo '</label></legend>';
}
echo '
<div id="code">', $context['nopaste']['code'], '
</div>
				</td>
			</tr>
		</table>';
}
function template_delpaste(){
	global $txt, $context;

	echo '<div style="padding: 3px;">', theme_linktree(), '</div>';
  
	echo '<br />
		<table width="100%" border="0" cellspacing="0" cellpadding="4" align="center" class="tborder">
			<tr class="catbg">
				<td>', $txt['lbl_Delete2'], '</td>
			</tr>
			<tr>
				<td class="windowbg">
          ', $context['nopaste']['status'], '
  				</td>
			</tr>
		</table>';
  nopaste_footer();
}
function template_showlink(){
  global $context, $txt;
  
	echo '
    <table width="100%" border="0" cellspacing="0" cellpadding="4" align="center" class="tborder">
			<tr class="catbg">
				<td>', $txt['lbl_Saved'], '</td>
			</tr>
			<tr>
				<td class="windowbg">
          <p style="font-size:12px;">', $txt['link_text'], '<p />
          <p style="font-weight:bold;">', $context['nopaste']['link'], '<p />
          <p style="font-size:12px;">', $txt['link_text_delete'], $context['nopaste']['deletelnk'], '<p />
  			</td>
			</tr>
		</table>';
	nopaste_footer();
}
function template_showsnippets(){
  global $context, $txt, $scripturl;
  $i=0;

	echo '
	<form action="', $scripturl, '?action=managenopaste;sa=delete" method="post" accept-charset="', $context['character_set'], '">
		<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
			<tr class="catbg">
				<td align="left" colspan="8">
					<b>', $txt[139], ':</b> ', $context['page_index'], '
				</td>
			</tr>
			<tr class="titlebg">
        <td valign="top">', $txt['lbl_Id'], '</td>
        <td valign="top">', $txt['lbl_Name'], '</td>
        <td valign="top">', $txt['lbl_IP'], '</td>
        <td valign="top">', $txt['lbl_Description2'], '</td>
        <td valign="top">', $txt['lbl_Date'], '</td>
        <td valign="top">', $txt['lbl_Lang'], '</td>
        <td valign="top">', $txt['lbl_Delete'], '</td>
      </tr>';
   
 	if (empty($context['nopaste']['snippets']))
		echo '
			<tr>
				<td class="windowbg" colspan="8">(', $txt['search_no_results'], ')</td>
			</tr>';
	else
	{
   foreach ($context['nopaste']['snippets'] as $nopaste){
      $i++;
      $class = ($i % 2 == 0) ? 'class="windowbg2"' : 'class="windowbg"';

      echo '
			<tr>
				<td ', $class, ' width="5%">
					<a href="', $nopaste['link'], '">', $nopaste['id'], '</a>
				</td>
				<td ', $class, '>
					', $nopaste['name'], '
				</td>
				<td ', $class, '>
					', $nopaste['ip'], '
				</td>
				<td ', $class, '>
					', $nopaste['description'], '
				</td>
				<td ', $class, '>
					', $nopaste['date'], '
				</td>
				<td ', $class, '>
					', $nopaste['lang'], '
				</td>
				<td align="center" class="windowbg2" width="5%">
					<input type="checkbox" name="delete[]" value="', $nopaste['id'], '" class="check" />
				</td>
 			</tr>';
   }
  }
  echo '
			<tr>
				<td class="windowbg2" align="left" colspan="3">
					<input type="submit" name="delete_all" value="' . $txt['lbl_Delete5'] . '" onclick="return confirm(\'' . $txt['lbl_Delete4'] . '\');" />
				</td>
				<td class="windowbg2" align="right" colspan="4">
					<input type="submit" name="delete_members" value="' . $txt['lbl_Delete2'] . '" onclick="return confirm(\'' . $txt['lbl_Delete3'] . '\');" />
				</td>
			</td>
    </table>
  </form>';
}
function template_showsettings(){
		global $txt, $scripturl, $settings, $modSettings, $context;

	echo '
		<div>
		<form action="', $scripturl, '?action=managenopaste;sa=save" method="post">
		<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
			<tr class="titlebg">
				<td colspan="2">', $txt['lbl_Settings'] ,'</td>
			</tr>
			<tr class="windowbg2">
				<td width="35%" align="left"><a href="', $scripturl, '?action=helpadmin;help=nopaste_public_key" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" align="top" /></a>&nbsp;', $txt['lbl_APIKey'] ,'</td>
				<td width="65%"><input type="text" size="48" name="api" value="', !empty($modSettings['nopaste_public_key']) ? $modSettings['nopaste_public_key'] : '', '" /></td>
			</tr>
			<tr class="windowbg2">
				<td width="35%" align="left"><a href="', $scripturl, '?action=helpadmin;help=nopaste_private_key" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" align="top" /></a>&nbsp;', $txt['lbl_APIKey2'] ,'</td>
				<td width="65%"><input type="text" size="48" name="api2" value="', !empty($modSettings['nopaste_private_key']) ? $modSettings['nopaste_private_key'] : '', '" /></td>
			</tr>
			<tr class="windowbg2">
				<td width="35%" align="left"><a href="', $scripturl, '?action=helpadmin;help=nopaste_theme" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" align="top" /></a>&nbsp;', $txt['lbl_Theme'] ,'</td>
				<td width="65%"><select name="theme">', $context['nopaste']['themes'], '</select></td>
			</tr>
			<tr class="windowbg2">
					<td colspan="2" align="right" style="padding-top: 1ex;">
						<input type="submit" name="add" value="', $txt['lbl_Save'], '" />
					</td>
			</tr>
		</table></form></div>';
}
?>
